Imports System.IO
Imports System.Xml.Serialization

<Serializable()>
Public Class uiSession
    Public Property LastAccessed As DateTime = Date.MinValue
    Public Property ActiveForm As String = String.Empty
    Public Property uiSessionFileName As String = String.Empty

    Public Overloads Function ToXML(ByVal pObj As uiSession) As String
        Dim xmlSerializer As New XmlSerializer(GetType(uiSession))
        Dim strWriter As New StringWriter()
        xmlSerializer.Serialize(strWriter, pObj)
        Return strWriter.ToString
    End Function
    Public Overloads Function FromXML(ByVal pstr As String) As uiSession
        Dim string_reader As StringReader
        Dim xmlSerializer As New XmlSerializer(GetType(uiSession))
        string_reader = New StringReader(pstr)
        Return xmlSerializer.Deserialize(string_reader)
    End Function
    Public Function ReadXML() As uiSession
        Dim io As New hdBO.Plumbing.dcFileIO
        Dim data As New uiSession

        If io.FileExists(Wisej.Web.Application.StartupPath & "\SessionState\" & SessionFileName()) Then
            data = data.FromXML(io.ReadLockedTextFile(Wisej.Web.Application.StartupPath & "\SessionState\" & SessionFileName()))
        End If

        Return data
    End Function
    Public Sub SaveXML()
        Dim io As New hdBO.Plumbing.dcFileIO
        io.CreateFolder(Wisej.Web.Application.StartupPath & "\SessionState")

        Me.LastAccessed = Now
        io.WriteTextFile(Wisej.Web.Application.StartupPath & "\SessionState", SessionFileName(), ToXML(Me), True)
    End Sub
    Public Shared Sub SaveSession(pFormName As String)
        Dim mObj As New uiSession
        mObj.ActiveForm = pFormName
        mObj.LastAccessed = Now
        mObj.uiSessionFileName = mObj.SessionFileName()
        mObj.SaveXML()
    End Sub
    Private Function SessionFileName() As String
        Dim xName As String = "uiSession.xml"

        'If hdWiseJ_Library.hdSecurity.IPAddress.Contains(":") = True Then
        '    xName = "uiSession_localhost.xml"
        'Else
        '    xName = "uiSession_" & hdWiseJ_Library.hdSecurity.IPAddress & ".xml"
        'End If
        Return xName
    End Function
End Class

